# This benchmark specification file describes a training
# set with four benchmarks.  Please refer to the reader's
# guide for a detailed description of the anatomy of the
# specification file.

newbench {
  $time       = "/usr/bin/time --output=fitness --format=%U ";
  $bench      = "wc";
  $commopts   = "-O3 ";
  $srcs       = "$PWD/wc/wc.c";
  $clean      = "rm -f *";
  setup       = "$clean";
  compile     = "opencc $commopts $srcs -o $bench";
  link        = "";
  run         = "($time $bench $PWD/wc/bigtext.txt > outputf)";
  check       = "grep 167860 outputf", "grep 1056928 outputf",
	        "grep 7870040 outputf";
  clean       = "$clean";
}

newbench {
  $time       = "/usr/bin/time --output=fitness --format=%U ";
  $bench      = "bubble";
  $commopts   = "-O3 ";
  $srcs       = "$PWD/bubblesort/main.c";
  $clean      = "rm -f *";
  setup       = "$clean";
  compile     = "opencc $commopts $srcs -o $bench";
  link        = "";
  run         = "($time $bench > outputf)";
  check       = "grep Success outputf";
  clean       = "$clean";
}

newbench {
  $time       = "/usr/bin/time --output=fitness --format=%U ";
  $bench      = "edge";
  $commopts   = "-O3 ";
  $srcs       = "$PWD/edge_detect/main.c";
  $clean      = "rm -f *";
  setup       = "$clean";
  compile     = "opencc $commopts $srcs -o $bench";
  link        = "";
  run         = "($time $bench > outputf)";
  check       = "grep Success outputf";
  clean       = "$clean";
}

newbench {
  $time       = "/usr/bin/time --output=fitness --format=%U ";
  $bench      = "jacobi";
  $commopts   = "-O3 ";
  $srcs       = "$PWD/jacobi/main.c";
  $clean      = "rm -f *";
  setup       = "$clean";
  compile     = "opencc $commopts $srcs -o $bench";
  link        = "";
  run         = "($time $bench > outputf)";
  check       = "grep Success outputf";
  clean       = "$clean";
}
