/****************************************************************************
 *
 *  Jacobi
 *
 ***************************************************************************/


#define ITER   10000
#define SIZEX  128
#define SIZEY  128
#define WIDTH   8

int main() {
  int r;
  int i,j;
  int a[SIZEX][SIZEY];
  int b[SIZEX][SIZEY];
  int checksum;
  int ans = 2097152;

  /* Initialize data array */

  for (i=0;i<SIZEX;i++) {
    for (j=0;j<SIZEY;j++) {

      /* an abitrary boundary condition of the appropriate WIDTH */	  
      a[i][j] = 1 << (WIDTH-1);
      b[i][j] = 1 << (WIDTH-1);

    }
  }
  
  for (r=0;r<ITER;r+=2) {
    for (i=1;i<SIZEX-1;i++) {
      for (j=1;j<SIZEY-1;j++)
	{
	  a[i][j] = (b[i-1][j] + b[i+1][j] + b[i][j-1] + b[i][j+1])>>2;
	}
    }
    for (i=1;i<SIZEX-1;i++) {
      for (j=1;j<SIZEY-1;j++)
	{
	  b[i][j] = (a[i-1][j] + a[i+1][j] + a[i][j-1] + a[i][j+1])>>2;
	}
    }
  }
  
  /* check sum */
  checksum = 0;
  for (i=0;i<SIZEX;i++)
    for (j=0;j<SIZEY;j++)
      checksum += b[i][j];
  
  printf("Checksum = %d\n", checksum);
  
  if(checksum==ans)
  {
    printf ("Success!\n");
    return 0; 
  }
  else
    return 1;
}
