/************************************************************************
 *
 *   File: common.h:
 *   
 *   Author: Mark Stephenson
 *   Date: Mon Aug  5 14:20:58 2002
 *
 *   Function: Contains common definitions and dispatch tables. 
 *
 ***********************************************************************/

#ifndef _COMMON_DEFS_H__
#define _COMMON_DEFS_H__

#include <sys/types.h>

typedef int32_t   int32;
typedef u_int32_t uint32;

/* Various tokens used for parsing. */
#define DBLVAL    0
#define INTVAL    1
#define BOOLVAL   2
#define DBLARG    3
#define BOOLARG   4
#define LCURLY    5
#define RCURLY    6
#define LBRACKET  7
#define RBRACKET  8
#define LPAREN    9
#define RPAREN    10
#define FUNCTION  11
#define COLON     12
#define FILEEND   13
#define AT        14
#define ERROR     15

#define DOUBLE   0
#define BOOLEAN  1

/* genetic_expression return value. */
typedef union {
  int32 i;
  double d;
} lval;


#endif
