/*************************************************************************
 *
 *   File: compiler_utils.cc:
 *   
 *   Author: Mark Stephenson
 *   Date: Wed Jul 17 11:52:18 2003
 *
 *   Function: A few functions that handle compiling and running
 *             of the benchmarks.
 *
 ************************************************************************/


#ifndef _COMPILER_UTILS_H__
#define _COMPILER_UTILS_H__

#include "genetic_expr.h"
#include "benchmark_set.h"
#include <dirent.h>

// A global flag that specifies verbosity.
extern bool g_verbose;

// Executes the commands in the command list.
void execute_commands (command_list *cmds, bool = false);

// Removes a file or recursively deletes a directory.
bool finch_clean_dir (const string& name, int(*select)(const struct dirent*));
bool finch_unlink    (const string& name, int(*select)(const struct dirent*));

// A signal handler to catch C-c events.
void finch_sigint (int);

#endif
