package edu.mit.lcs.cag.metaopt;

public class Finch
{
    /**
     * Initialize the finch library.  This function should only
     * be called once at the start of the pass.
     */
    public static native void initializeLib();

    /**
     * Evaluate the current priority function with the provided
     * arguments.
     *
     * @param dbls   ordered array of double parameters to the function
     * @param bools  ordered array of boolean parameters to the function
     * @return       value of the priority function, evaluated with
     *               the supplied parameters
     */
    public static native double evaluateReal(double[] dbls, boolean[] bools);

    /**
     * Evaluate the current priority function with the provided
     * arguments.
     *
     * @param dbls   ordered array of double parameters to the function
     * @param bools  ordered array of boolean parameters to the function
     * @return       value of the priority function, evaluated with
     *               the supplied parameters
     */
    public static native boolean evaluteBinary(double[] dbls, boolean[] bools);

    /**
     * Clean up the finch library.
     */
    public static native void finalizeLib();

    /*
     * Initialization code:
     */
    static
    {
        System.loadLibrary("finch_jni");
    }
}
